varying highp mat2 vRotate;

varying lowp vec4 vColor;
uniform sampler2D sBrush;

void main(void) {
    lowp vec2 center = gl_PointCoord.xy - 0.5;
    lowp vec2 uv = (center * vRotate) + 0.5;
    lowp vec4 textureColor = texture2D(sBrush, uv);
    lowp float highlight = textureColor.g;
    lowp float clip = step(dot(center, center), 0.25);
    lowp float tint = textureColor.b - textureColor.g;
    gl_FragColor.rgb = vec3(highlight) + vColor.rgb * tint;
    gl_FragColor.a = textureColor.a;
    gl_FragColor *= clip;
}
