attribute vec4 aPosition;
attribute vec2 aVelocity;
attribute highp float aTime;

uniform mat4 uMVPMatrix;
uniform mediump float uSize;
uniform lowp vec4 uColor;
uniform lowp vec4 uPalette[8];
varying lowp vec4 vColor;
varying highp mat2 vRotate;

// random rand pulled from the interwebs
highp float rand(vec2 co)
{
    highp float a = 12.9898;
    highp float b = 78.233;
    highp float c = 43758.5453;
    highp float dt= dot(co.xy ,vec2(a,b));
    highp float sn= mod(dt,3.14);
    return fract(sin(sn) * c);
}

lowp float isWhite(vec4 color) {
    return step(dot(color, color), 3.99);
}

void main(void) {

    vec4 pos4 = aPosition;
    vec2 seed = aPosition.xy;
    highp float t = rand(seed) * 3.2;
    seed += t;
    highp float t2 = step(0.5, rand(seed)) - 0.5;

    seed += t2;
    highp float t3 = rand(seed);

    vRotate[0][0] = cos(t);
    vRotate[0][1] = sin(t);

    vRotate[1][0] = vRotate[0][1];
    vRotate[1][1] = -vRotate[0][0];

    highp float safeLen = max(0.00001, length(aVelocity));
    highp vec2 normal = aVelocity.yx / safeLen;

    highp float t4 = rand(seed);
    int confettiIndex = int(7.999 * step(0.01, aTime) * t4);
    vColor = mix(uPalette[confettiIndex], uColor, isWhite(uColor));

    pos4.xy +=  t2 * uSize * normal * 0.4;

    gl_Position = uMVPMatrix * pos4;
    gl_PointSize = uSize * (0.7 + 0.7 * t3);
}